# -*- coding: utf-8 -*-
import numpy as np

#------------------------------------------------------------------------------
def lineSpline(line, characterWidth, separatorWidth, italicise, narrow):
    ''' Build points for one line '''

    characterSeparatorWidth = characterWidth + separatorWidth

    x_separator = np.array([0.5])
    y_separator = np.array([0.125])
    x_sp = x_separator
    y_sp = y_separator

    x_a = np.array([0  , 0.5, 1  , 0.5, 0  , 0.5, 1  , 0.95, 1   , 1, 1   ])
    y_a = np.array([0.5, 1  , 0.5, 0  , 0.5, 1  , 0.5, 0.25, 0.75, 1, 0.25])
    x_b = np.array([0.4, 0.125, 0  , 0.5, 1  , 0.5, 0   , 0.5])
    y_b = np.array([1  , 2    , 0.5, 0  , 0.5, 1  , 0.25, 0  ])
    x_c = np.array([0  , 0.5, 1, 0.5, 0  , 0.5 ])
    y_c = np.array([0.5, 1  , 1, 1  , 0.5, 0])
    x_d = np.array([0  , 0.5, 1  , 0.5, 0  , 0.5, 1  , 0.95, 1   , 1, 1   ])
    y_d = np.array([0.5, 1  , 0.5, 0  , 0.5, 1  , 0.5, 0.25, 0.75, 2, 0.25])

    x_e = np.array([0  , 0.5, 1   , 0.5, 0  , 0.5])
    y_e = np.array([0.4, 0.5, 0.75, 1  , 0.5, 0  ])
    x_f = 0.25 + np.array([0.5, 0.125, 0  , 0.125, 0.5 , 0.25, 0    , 0.5  ])
    y_f =        np.array([1  , 2    , 0.5, -1   , -0.5, 0.25, 0.125, 0.125])
    x_g = np.array([0  , 0.5, 1  , 0.5, 0  , 0.5, 1  ,  0.9,  0.5])
    y_g = np.array([0.5, 1  , 0.5, 0  , 0.5, 1  , 0.5, -1  , -0.5])
    x_h = np.array([0.5, 0.125, 0  , 0, 0  , 0.5, 0.95, 0.95, 1])
    y_h = np.array([1.5, 2    , 0.5, 0, 0.5, 1  , 0.6 , 0.25, 0])

    x_i = np.array([0.4, 0.5, 0.5, 0.75])
    y_i = np.array([0.5, 1  , 0.5, 0   ])
    x_j = np.array([0.4, 0.5,  0.5,  0.25])
    y_j = np.array([0.5, 1  , -1  , -0.4 ])
    x_k = np.array([0.3, 0.4, 0.125, 0  , 0, 0  , 0.5, 1   , 0.75, 0.75, 0.9, 1])
    y_k = np.array([1  , 1.5, 2    , 0.5, 0, 0.5, 1  , 0.75, 0.25, 0.5 , 0.3, 0])
    x_l = 0.25 + np.array([0.5 , 0.125, 0.1, 0.5])
    y_l =        np.array([1.25, 2    , 0.5, 0  ])

    x_m = np.array([0  , 0.15, 0.33, 0.33, 0.33, 0.5, 0.66, 0.66, 0.66, 0.85, 1  , 1])
    y_m = np.array([0.5, 1   , 0.5 , 0   , 0.5 , 1  , 0.5 , 0   , 0.5 , 1   , 0.5, 0])
    x_n = np.array([0  , 0.25, 0.5, 0.5, 0.5, 0.75, 1  , 1])
    y_n = np.array([0.5, 1   , 0.5, 0  , 0.5, 1   , 0.5, 0])
    x_o = np.array([0  , 0.5, 1  , 0.5, 0  , 0.5, 0.95, 0.6 , 0.9 ])
    y_o = np.array([0.5, 1  , 0.5, 0  , 0.5, 1  , 0.6 , 0.65, 0.75])
    x_p = np.array([0  , 0.5, 1  , 0.5, 0  , 0   , 0,  0  ,  0, 0.1, 0.5])
    y_p = np.array([0.5, 1  , 0.5, 0  , 0.4, 0.75, 1, -0.5, -1, 0  , 0  ])

    x_q = np.array([0  , 0.5, 1  , 0.5, 0  , 0.5, 1  ,  1  ,  1])
    y_q = np.array([0.5, 1  , 0.5, 0  , 0.5, 1  , 0.5, -0.5, -1])
    x_r = np.array([0.05, 0.2, 0.1, 0.2, 0.8, 0.8, 0.8])
    y_r = np.array([0.4 , 0.9, 1  , 0.9, 0.9, 0.5, 0  ])
    x_s = np.array([0.4, 0.9, 0.9, 1  , 1  , 0.7, 0.7, 0.9, 1])
    y_s = np.array([0.5, 1  , 1  , 0.6, 0.2, 0  , 0.1, 0  , 0])
    x_t = np.array([0.5, 0.5, 0.5, 0.2, 0.8, 0.55, 0.6, 0.9])
    y_t = np.array([0.7, 2  , 1.6, 1.5, 1.5, 1.35, 0.2, 0  ])

    x_u = np.array([0  , 0, 0   , 0.5, 0.9, 0.9, 0.9 ])
    y_u = np.array([0.5, 1, 0.25, 0  , 0.3, 1  , 0.15])
    x_v = np.array([0, 0.5, 1  , 0.9, 0.9, 1  , 1  ])
    y_v = np.array([1, 0  , 0.9, 1  , 0.9, 0.8, 0.1])
    x_w = np.array([0, 0.1, 0.25, 0.5, 0.5, 0.5, 0.75, 1  , 1, 0.9, 1  , 1  ])
    y_w = np.array([1, 0.5, 0   , 0.5, 1  , 0.5, 0   , 0.5, 1, 0.9, 0.8, 0.1])
    x_x = np.array([0.25, 0.5, 0.25, 0  , 0.5, 1  , 0.75, 0.5, 0.75])
    y_x = np.array([0   , 0.5, 1   , 0.9, 1  , 0.9, 1   , 0.5, 0   ])

    x_y = np.array([0  , 0, 0  , 0.5, 1  , 1, 1  ,  0.9,  0.5])
    y_y = np.array([0.5, 1, 0.5, 0  , 0.5, 1, 0.5, -1  , -0.5])
    x_z = np.array([0  , 0.5, 1  , 0.75, 0.5, 0.75,  1   ,  0.9,  0.5])
    y_z = np.array([0.5, 1  , 0.5, 0   , 0.1, 0.2 , -0.25, -1  , -0.5])

    x = np.array([])
    y = np.array([])

    for character in range(0, len(line)):
        code = line[character]
        if code == ' ':
            code = 'sp'
        xcode = np.array(eval(eval("'x_' + code")))
        ycode = np.array(eval(eval("'y_' + code")))
        x = np.append(x, xcode + character*characterSeparatorWidth)
        y = np.append(y, ycode)
        x = np.append(x, x_separator*separatorWidth + character*characterSeparatorWidth + characterWidth)
        y = np.append(y, y_separator)

    x = x + italicise*y
    x = narrow*x

    return x, y

#------------------------------------------------------------------------------
def crSpline(lineEnd, offset, lineHeight):
    ''' Build points for one line '''

    xOffset = lineEnd/10;

    x = np.array([lineEnd, lineEnd, lineEnd-xOffset, lineEnd-2*xOffset, 2*xOffset, 0.1*xOffset,  0           ,  0                  ])
    y = np.array([0      , -offset, -offset        , -offset          , -offset  , -2*offset  , -lineHeight/2, -lineHeight+2*offset])

    return x, y

#------------------------------------------------------------------------------
def spline(points, oversampling_ratio, polynom_order):
    ''' Build spline from points vector '''

    samples = np.zeros([1, polynom_order+1])
    mySpline = np.array([])
    for index in range(0, len(points)):
        samples = np.roll(samples, len(samples)-2)
        samples[:, -1] = points[index]
        coeff = [[ -1,  2, -1,  0 ],
                 [  3, -5,  0,  1 ],
                 [ -3,  4,  1,  0 ],
                 [  1, -1,  0,  0 ]]
        coeff2 = samples.dot(coeff).flatten(1)
        x = 2*coeff2[3] * oversampling_ratio**3
        u = coeff2[0] + coeff2[1]*oversampling_ratio + coeff2[2]*oversampling_ratio**2
        v = 6*coeff2[0] + 2*coeff2[1]*oversampling_ratio
        w = 6*coeff2[0]
        mySpline = np.append(mySpline, coeff2[3])
        for index2 in range(0, oversampling_ratio):
            x = x + u;
            u = u + v;
            v = v + w;
            mySpline = np.append(mySpline, x / (2*oversampling_ratio**3))

    return mySpline

#------------------------------------------------------------------------------
import binascii
def write_txt_bin(text, text_file_id, binary_file_id):
    ''' Write text to the text file and to the binray file handles'''
    text_file_id.write(text)
    binary_file_id.write(binascii.a2b_hex(text.replace(' ', '')))

#------------------------------------------------------------------------------
def scale(to_scale, spline):
    ''' Scale the points in the given arrays to a value 0 < x < 1'''
    # values = 0 are not well displayed at the oscilloscope
    # -1 is to assure to be > and not = 0
    offset_to_0 = min(spline)-1
    scale_to_1 = max(spline)-offset_to_0
    scaled = (to_scale-offset_to_0)/scale_to_1
    return scaled

#------------------------------------------------------------------------------
def text2points(text, character_width=1,
                      separator_width=0.25,
                      italicise=0.5,
                      crOffset=0.125,
                      lineHeight=4,
                      narrow=0.75):
    ''' Generate two arrays of points to display the given text '''
    x = []
    y = []
    for index in range(0, np.shape(text)[0]):
        line = text[index].strip().lower()
        (xLine, yLine) = lineSpline(
            line, character_width, separator_width, italicise, narrow)
        lineOffset = -(index)*lineHeight
        if (index < np.shape(text)[0]-1):
            crHeight = lineHeight
        else:
            crHeight = -(index-1)*lineHeight
        (xCr, yCr) = crSpline(
            xLine[-1] + separator_width, crOffset, crHeight)
        x = np.append(x, np.append(xLine           , xCr))
        y = np.append(y, np.append(yLine+lineOffset, yCr+lineOffset))
    return x, y