#===============================================================================
# Build points for one line
#
function [x, y] = lineSpline(line, characterWidth, separatorWidth, italicise, narrow)

characterSeparatorWidth = characterWidth + separatorWidth;
separatorHeigth = 0.125;

x_separator = [0.5];
y_separator = [separatorHeigth];
x_sp = x_separator;
y_sp = y_separator;

x_a = [0  , 0.5, 1  , 0.5, 0  , 0.5, 1  , 0.95, 1   , 1, 1   ];
y_a = [0.5, 1  , 0.5, 0  , 0.5, 1  , 0.5, 0.25, 0.75, 1, 0.25];
x_b = [0.4, 0.125, 0  , 0.5, 1  , 0.5, 0   , 0.5];
y_b = [1  , 2    , 0.5, 0  , 0.5, 1  , 0.25, 0  ];
x_c = [0  , 0.5, 1, 0.5, 0  , 0.5 ];
y_c = [0.5, 1  , 1, 1  , 0.5, 0];
x_d = [0  , 0.5, 1  , 0.5, 0  , 0.5, 1  , 0.95, 1   , 1, 1   ];
y_d = [0.5, 1  , 0.5, 0  , 0.5, 1  , 0.5, 0.25, 0.75, 2, 0.25];

x_e = [0  , 0.5, 1   , 0.5, 0  , 0.5];
y_e = [0.4, 0.5, 0.75, 1  , 0.5, 0  ];
x_f = 0.25 + [0.5, 0.125, 0  ,  0.125,  0.5, 0.25, 0    , 0.5  ];
y_f =        [1  , 2    , 0.5, -1    , -0.5, 0.25, 0.125, 0.125];
x_g = [0  , 0.5, 1  , 0.5, 0  , 0.5, 1  ,  0.9,  0.5];
y_g = [0.5, 1  , 0.5, 0  , 0.5, 1  , 0.5, -1  , -0.5];
x_h = [0.5, 0.125, 0  , 0, 0  , 0.5, 0.95, 0.95, 1];
y_h = [1.5, 2    , 0.5, 0, 0.5, 1  , 0.6 , 0.25, 0];

x_i = [0.4, 0.5, 0.5, 0.75];
y_i = [0.5, 1  , 0.5, 0   ];
x_j = [0.4, 0.5,  0.5,  0.25];
y_j = [0.5, 1  , -1  , -0.4 ];
x_k = [0.3, 0.4, 0.125, 0  , 0, 0  , 0.5, 1   , 0.75, 0.75, 0.9, 1];
y_k = [1  , 1.5, 2    , 0.5, 0, 0.5, 1  , 0.75, 0.25, 0.5 , 0.3, 0];
x_l = 0.25 + [0.5 , 0.125, 0.1, 0.5];
y_l =        [1.25, 2    , 0.5, 0   ];

x_m = [0  , 0.15, 0.33, 0.33, 0.33, 0.5, 0.66, 0.66, 0.66, 0.85, 1  , 1];
y_m = [0.5, 1   , 0.5 , 0   , 0.5 , 1  , 0.5 , 0   , 0.5 , 1   , 0.5, 0];
x_n = [0  , 0.25, 0.5, 0.5, 0.5, 0.75, 1  , 1];
y_n = [0.5, 1   , 0.5, 0  , 0.5, 1   , 0.5, 0];
x_o = [0  , 0.5, 1  , 0.5, 0  , 0.5, 0.95, 0.6 , 0.9 ];
y_o = [0.5, 1  , 0.5, 0  , 0.5, 1  , 0.6 , 0.65, 0.75];
x_p = [0  , 0.5, 1  , 0.5, 0  , 0   , 0,  0  ,  0, 0.1, 0.5];
y_p = [0.5, 1  , 0.5, 0  , 0.4, 0.75, 1, -0.5, -1, 0  , 0  ];

x_q = [0  , 0.5, 1  , 0.5, 0  , 0.5, 1  ,  1  ,  1];
y_q = [0.5, 1  , 0.5, 0  , 0.5, 1  , 0.5, -0.5, -1];
x_r = [0.05, 0.2, 0.1, 0.2, 0.8, 0.8, 0.8];
y_r = [0.4 , 0.9, 1  , 0.9, 0.9, 0.5, 0  ];
x_s = [0.4, 0.9, 0.9, 1  , 1  , 0.7, 0.7, 0.9, 1];
y_s = [0.5, 1  , 1  , 0.6, 0.2, 0  , 0.1, 0  , 0];
x_t = [0.5, 0.5, 0.5, 0.2, 0.8, 0.55, 0.6, 0.9];
y_t = [0.7, 2  , 1.6, 1.5, 1.5, 1.35, 0.2, 0  ];

x_u = [0  , 0, 0   , 0.5, 0.9, 0.9, 0.9 ];
y_u = [0.5, 1, 0.25, 0  , 0.3, 1  , 0.15];
x_v = [0, 0.5, 1  , 0.9, 0.9, 1  , 1  ];
y_v = [1, 0  , 0.9, 1  , 0.9, 0.8, 0.1];
x_w = [0, 0.1, 0.25, 0.5, 0.5, 0.5, 0.75, 1  , 1, 0.9, 1  , 1  ];
y_w = [1, 0.5, 0   , 0.5, 1  , 0.5, 0   , 0.5, 1, 0.9, 0.8, 0.1];
x_x = [0.25, 0.5, 0.25, 0  , 0.5, 1  , 0.75, 0.5, 0.75];
y_x = [0   , 0.5, 1   , 0.9, 1  , 0.9, 1   , 0.5, 0   ];

x_y = [0  , 0, 0  , 0.5, 1  , 1, 1  ,  0.9,  0.5];
y_y = [0.5, 1, 0.5, 0  , 0.5, 1, 0.5, -1  , -0.5];
x_z = [0  , 0.5, 1  , 0.75, 0.5, 0.75,  1   ,  0.9,  0.5];
y_z = [0.5, 1  , 0.5, 0   , 0.1, 0.2 , -0.25, -1  , -0.5];

x = [];
y = [];

for character = 1:length(line),
  code = line(character);
  if code == ' '
    code = 'sp';
  end
  eval(['x = [x, x_' code ' + (character-1)*characterSeparatorWidth];']);
  eval(['y = [y, y_' code '];']);
  x = [x, x_separator*separatorWidth + (character-1)*characterSeparatorWidth + characterWidth];
  y = [y, y_separator];
end

x = x + italicise*y;
x = narrow*x;
